﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace typingCS {
    public partial class EtcForm : Form {
        public static byte[]ENG_RATIO_TBL={0,10,20,30,40,50,60,70,80,90,95,99,100,101};
        const string SAFE_STR1="全確定まで進めない(&S)";
        const string SAFE_STR2="確定後のEnterまで進めない(&S)";
        static bool protect;
        public byte basic;
        public byte eng;
        public byte ratio;
        public byte color;
        public byte[]hist;
        public bool sound;
        public bool always;
        public bool mem;
        public bool[]rightz;
        public bool[]safe;
        public bool shortz;
        public bool exact;
        public bool[]del;
        public bool bs;
        public bool surr;
        public byte k2;
        public bool kconv;
        public bool[]autoback;
        public byte[]hold;
        public bool[]swap;
        public bool morning;
        public byte delay;
        public byte[]multi;
        public bool bin;
        public bool[]word;

        public EtcForm()
        { InitializeComponent(); }

        public void SetDialog() {
            int i;
            protect=true;
            MainForm.DlgSz = 14;
            MainForm.DlgWidth=MainForm.DLG_WIDTH;
            MainForm.DlgLabel=MainForm.DLG_LABEL;
            MainForm.DlgBase=MainForm.DLG_MARGIN_TOP;
            MainForm.DlgCombo=MainForm.DLG_COMBO_NUM;
            MainForm.DlgCnt=0;
            if (MainForm.AutoBackMode) {
                for (i=0;i<MainForm.MAX_HOLD;i++) HoldCombo.Items.Add((i+basic).ToString());
            }
            for (i=0;i<ENG_RATIO_TBL.Length;i++) EngCombo.Items.Add(ENG_RATIO_TBL[i].ToString());
            for (i=0;i<ENG_RATIO_TBL.Length-1;i++) if (ENG_RATIO_TBL[i]==ratio) break;
            EngCombo.SelectedIndex=i;
            for (i=0;i<MainForm.SZ_HIST;i++) HistCombo.Items.Add(i.ToString());
            HistCombo.SelectedIndex=hist[eng];
            for (i=0;i<MainForm.OK_COLOR_TBL.Length;i++) ColorCombo.Items.Add(MainForm.OK_COLOR_TBL[i].ToString());
            for (i=0;i<MainForm.OK_COLOR_TBL.Length-1;i++) if (MainForm.OK_COLOR_TBL[i]==color) break;
            ColorCombo.ItemHeight=MainForm.DLG_FONT_SIZE+2;
            ColorCombo.SelectedIndex=i;
            for (i=0;i<MainForm.SZ_K2;i++) K2Combo.Items.Add(((10.0+i*2)/10.0).ToString("0.0"));
            K2Combo.SelectedIndex=(k2-10)/2;
            for (i=1;i<=MainForm.MAX_MULTI;i++) MultiCombo.Items.Add(i.ToString());
            SoundCheck.Checked=sound;
            AlwaysCheck.Checked=always;
            SurrCheck.Checked=surr;
            MemCheck.Checked=mem;
            ExactCheck.Checked=exact;
            RightCheck.Checked=rightz[eng];
            if (MainForm.MultiMode) {
                SafeCheck.Checked=safe[multi[eng]>1||eng!=0?1:0];
                SafeCheck.Text=multi[eng]>1||eng!=0?SAFE_STR2:SAFE_STR1;
            } else SafeCheck.Checked=safe[eng];
            ShortCheck.Checked=shortz;
            DelCheck.Checked=del[eng];
            BsCheck.Checked=bs;
            WordCheck.Visible=false;
            SwapCheck.Visible=false;
            MorningCheck.Visible=false;
            KConvCheck.Visible=false;
            AutoBackCheck.Visible=false;
            HoldCombo.Visible=false;
            HoldLabel.Visible=false;
            MultiLabel.Visible=false;
            MultiCombo.Visible=false;
            BinCheck.Visible=false;
            DelayCombo.Visible=false;
            DelayLabel.Visible=false;
            if (MainForm.AutoBackMode) {
                MainForm.DlgSz+=2;
                AutoBackCheck.Text=(basic==0?"辞書ソフト":"ブラウザ")+"から自動復帰(&Q)";
                AutoBackCheck.Visible=true;
                AutoBackCheck.Checked=autoback[basic];
                HoldLabel.Visible=true;
                HoldCombo.Visible=true;
                HoldCombo.SelectedIndex=hold[basic]-basic;
            }
            if (MainForm.WordMode) {
                MainForm.DlgSz++;
                WordCheck.Visible=true;
                WordCheck.Checked=word[eng];
            }
            if (MainForm.BinMode) {
                MainForm.DlgSz++;
                BinCheck.Visible=true;
                BinCheck.Checked=bin;
            }
            if (MainForm.KConvMode) {
                MainForm.DlgSz++;
                KConvCheck.Visible=true;
                KConvCheck.Checked=kconv;
            }
            if (MainForm.SwapMode) {
                MainForm.DlgSz++;
                SwapCheck.Visible=true;
                SwapCheck.Checked=swap[eng];
            }
            if (MainForm.MorningMode) {
                MainForm.DlgSz++;
                MorningCheck.Text = "午前" + MainForm.MORNING.ToString() + "時まで日付を進めない(&X)";
                MorningCheck.Visible=true;
                MorningCheck.Checked=morning;
            }
            if (MainForm.EraseMode) {
                MainForm.DlgSz++;
                DelayLabel.Visible=true;
                DelayCombo.Visible=true;
                for (i=0;i<MainForm.SZ_DELAY;i++)
                    DelayCombo.Items.Add((i/10.0).ToString("0.0"));
                DelayCombo.SelectedIndex=delay;
            }
            if (MainForm.MultiMode) {
                MainForm.DlgSz++;
                MultiLabel.Visible=true;
                MultiCombo.Visible=true;
                MultiCombo.SelectedIndex=multi[eng]-1;
            }
            if (MainForm.CompactMode0) {
                bool b=MainForm.Num!=0;
                AutoBackCheck.Enabled=b;
                HoldCombo.Enabled=autoback[basic]&&b;
                HoldLabel.Enabled=autoback[basic]&&b;
                WordCheck.Enabled=multi[eng]>1&&b;
                EngCombo.Enabled=b;
                EngLabel.Enabled=b;
                HistCombo.Enabled=b;
                HistLabel.Enabled=b;
                MultiCombo.Enabled=b;
                MultiLabel.Enabled=b;
                SoundCheck.Enabled=b;
                AlwaysCheck.Enabled=b;
                RightCheck.Enabled=b;
                DelayLabel.Enabled=b;
                DelayCombo.Enabled=b;
                SwapCheck.Enabled=b;
                MorningCheck.Enabled=b;
                ExactCheck.Enabled=b;
                BsCheck.Enabled=b;
                DelCheck.Enabled=b;
                SafeCheck.Enabled=b;
                SurrCheck.Enabled=MainForm.HavePair&&b;
                K2Combo.Enabled=MainForm.HaveKanji&&b;
                K2Label.Enabled=MainForm.HaveKanji&&b;
                ShortCheck.Enabled=MainForm.HaveShort&&b;
                KConvCheck.Enabled=MainForm.HaveHanKana&&b;
                DelayLabel.Enabled=del[eng]&&b;
                DelayCombo.Enabled=del[eng]&&b;
            }else{
                HoldCombo.Enabled=autoback[basic];
                HoldLabel.Enabled=autoback[basic];
                WordCheck.Enabled=multi[eng]>1;
                SurrCheck.Enabled=MainForm.HavePair;
                K2Combo.Enabled=MainForm.HaveKanji;
                K2Label.Enabled=MainForm.HaveKanji;
                ShortCheck.Enabled=MainForm.HaveShort;
                KConvCheck.Enabled=MainForm.HaveHanKana;
                DelayLabel.Enabled=del[eng];
                DelayCombo.Enabled=del[eng];
            }
            if (MainForm.AutoBackMode) {
                MainForm.MyDlg(AutoBackCheck);
                MainForm.MyNumDlg(HoldCombo,HoldLabel);
            }
            if (MainForm.EraseMode) {
                MainForm.MyDlg(DelCheck);
                MainForm.MyNumDlg(DelayCombo,DelayLabel);
            }
            MainForm.MyNumDlg(EngCombo, EngLabel);
            MainForm.MyNumDlg(HistCombo,HistLabel);
            MainForm.MyNumDlg(K2Combo,K2Label);
            MainForm.MyNumDlg(ColorCombo, ColorLabel);
            if (MainForm.MultiMode) MainForm.MyNumDlg(MultiCombo,MultiLabel);
            if (MainForm.WordMode) MainForm.MyDlg(WordCheck);
            if (MainForm.BinMode) MainForm.MyDlg(BinCheck);
            MainForm.MyDlg(SoundCheck);
            MainForm.MyDlg(AlwaysCheck);
            MainForm.MyDlg(MemCheck);
            MainForm.MyDlg(RightCheck);
            if (MainForm.SwapMode) MainForm.MyDlg(SwapCheck);
            if (MainForm.KConvMode) MainForm.MyDlg(KConvCheck);
            MainForm.MyDlg(ShortCheck);
            MainForm.MyDlg(ExactCheck);
            MainForm.MyDlg(BsCheck);
            if (!MainForm.EraseMode) MainForm.MyDlg(DelCheck);
            MainForm.MyDlg(SurrCheck);
            if (MainForm.MorningMode) MainForm.MyDlg(MorningCheck);
            MainForm.MyDlg(SafeCheck);
            MainForm.OkCancel(this,MainForm.DlgBase+((MainForm.DlgSz+1)/2)*MainForm.DLG_INTERVAL,EtcOkButton,EtcCancelButton);
            protect=false;
        }

        private void OkButton_Click(object sender,EventArgs e) {
            ratio=ENG_RATIO_TBL[EngCombo.SelectedIndex];
            hist[eng]=(byte)HistCombo.SelectedIndex;
            color=MainForm.OK_COLOR_TBL[ColorCombo.SelectedIndex];
            if (MainForm.HaveKanji) k2=(byte)(K2Combo.SelectedIndex*2+10);
            sound=SoundCheck.Checked;
            always=AlwaysCheck.Checked;
            surr=SurrCheck.Checked;
            mem=MemCheck.Checked;
            rightz[eng]=RightCheck.Checked;
            multi[eng]=(byte)(MultiCombo.SelectedIndex+1);
            if (MainForm.MultiMode) {
                safe[multi[eng]>1||eng!=0?1:0]=SafeCheck.Checked;
            } else safe[eng]=SafeCheck.Checked;
            shortz=ShortCheck.Checked;
            del[eng]=DelCheck.Checked;
            bs=BsCheck.Checked;
            exact=ExactCheck.Checked;
            if (MainForm.EraseMode) delay=(byte)(DelayCombo.SelectedIndex);
            if (MainForm.KConvMode) kconv=KConvCheck.Checked;
            if (MainForm.AutoBackMode) {
                autoback[basic]=AutoBackCheck.Checked;
                hold[basic]=(byte)(HoldCombo.SelectedIndex+basic);
            }
            if (MainForm.SwapMode) swap[eng]=SwapCheck.Checked;
            if (MainForm.MorningMode) morning=MorningCheck.Checked;
            if (MainForm.BinMode) bin = BinCheck.Checked;
            if (MainForm.WordMode) word[eng]=WordCheck.Checked;
        }

        private void EngCombo_SelectedIndexChanged(object sender, EventArgs e) {
            if (protect) return;
            byte prev_eng=eng;
            ratio=ENG_RATIO_TBL[EngCombo.SelectedIndex];
            eng=(MainForm.EngPer>=ratio?(byte)1:(byte)0);
            if (eng!=prev_eng) {
                byte prev_mu;
                if (MainForm.MultiMode) {
                    prev_mu=(byte)(multi[prev_eng]>1||prev_eng!=0?1:0);
                } else prev_mu=0;
                hist[prev_eng]=(byte)HistCombo.SelectedIndex;
                rightz[prev_eng]=RightCheck.Checked;
                del[prev_eng]=DelCheck.Checked;
                word[prev_eng]=WordCheck.Checked;
                multi[prev_eng]=(byte)(MultiCombo.SelectedIndex+1);
                if (MainForm.SwapMode) swap[prev_eng]=SwapCheck.Checked;
                HistCombo.SelectedIndex=hist[eng];
                RightCheck.Checked=rightz[eng];
                DelCheck.Checked=del[eng];
                WordCheck.Checked=word[eng];
                MultiCombo.SelectedIndex=multi[eng]-1;
                if (MainForm.MultiMode) {
                    safe[prev_mu]=SafeCheck.Checked;
                    SafeCheck.Checked=safe[multi[eng]>1||eng!=0?1:0];
                    SafeCheck.Text=multi[eng]>1||eng!=0?SAFE_STR2:SAFE_STR1;
                    WordCheck.Enabled=multi[eng]>1;
                } else {
                    safe[0]=SafeCheck.Checked;
                    SafeCheck.Checked=safe[0];
                }
                if (MainForm.SwapMode) SwapCheck.Checked=swap[eng];
                if (MainForm.EraseMode) DelayLabel.Enabled=DelayCombo.Enabled=del[eng];
            }
        }

        private void MultiCombo_SelectedIndexChanged(object sender, EventArgs e) {
            if (protect) return;
            byte prev_mu=multi[eng];
            multi[eng]=(byte)(MultiCombo.SelectedIndex+1);
            if (multi[eng]!=prev_mu) {
                WordCheck.Enabled=multi[eng]>1;
                safe[prev_mu>1?1:0]=SafeCheck.Checked;
                SafeCheck.Checked=safe[multi[eng]>1||eng!=0?1:0];
                SafeCheck.Text=multi[eng]>1||eng!=0?SAFE_STR2:SAFE_STR1;
            }
        }

        private void ColorCombo_DrawItem(object sender, DrawItemEventArgs e) {
            e.DrawBackground();
            ComboBox cmb=(ComboBox)sender;
            string txt=e.Index>-1?cmb.Items[e.Index].ToString():cmb.Text;
            byte bc=e.Index>-1?MainForm.OK_COLOR_TBL[e.Index]:(byte)192;
            Color c=Color.FromArgb(bc,bc,(byte)(bc==(byte)160?(byte)164:bc));
            Brush b=new SolidBrush(c);
            try {
                float ym=(e.Bounds.Height-e.Graphics.MeasureString(txt,MainForm.FontDlg).Height)/2;
                e.Graphics.FillRectangle(b, new Rectangle((int)e.Bounds.X+1,(int)e.Bounds.Y+1,(int)e.Bounds.Width-2,(int)e.Bounds.Height-2));
                TextRenderer.DrawText(e.Graphics,txt,MainForm.FontDlg,new Rectangle((int)e.Bounds.X,(int)e.Bounds.Y,(int)e.Bounds.Width,(int)e.Bounds.Height),
                    bc<MainForm.BLACK_LEVEL?Color.White:Color.Black, c, TextFormatFlags.HorizontalCenter | TextFormatFlags.VerticalCenter);
                e.DrawFocusRectangle();
            } finally { b.Dispose(); }
        }

        private void AutoBackCheck_CheckedChanged(object sender, EventArgs e) {
            HoldLabel.Enabled=AutoBackCheck.Checked;
            HoldCombo.Enabled=AutoBackCheck.Checked;
        }

        private void DelCheck_CheckedChanged(object sender, EventArgs e) {
            if (MainForm.EraseMode) DelayCombo.Enabled=DelayLabel.Enabled=DelCheck.Checked;
        }

    }
}
